//Arkanoid Created By Marek Rudolf
#include "images.h"
#include <math.h>
#include <iostream.h>
#include <fstream.h>

ball::ball()
{
  size=8;
  x=0;
  y=0;            
}

void ball::draw()
{
   glLoadIdentity();
   glColor3f(0.4f,1.0f,0.2f);                                    
   glBegin(GL_TRIANGLE_FAN); 
   for (GLfloat a = 0; a<=2*M_PI; a+=2*M_PI/50)
   { 
      glVertex2f(x+cos(a)*size,y+sin(a)*size);
   } 
   glEnd();      
}

void ball::move()
{
   y+=yspeed;
   x+=xspeed;
}

int ball::colisiontest(GLfloat x1,GLfloat y1,GLfloat x2,GLfloat y2)
{

    int coll=0;   
    if ((x + xspeed + size >= x1
		 && x + xspeed - size <= x2)
		 && (y + yspeed + size >= y1
		 && y + yspeed - size <= y2))
		 {              
  		   if (x + size < x1 &&
					    x + xspeed + size >= x1)              
			  coll|=1;
           if (x - size > x2 &&
		 	   x + xspeed - size <= x2)                	    	                
              coll|=1;
          if (y + size < y1&&
					    y + yspeed + size >= y1)              
              coll|=2;					    
   		  if (y - size > y2 &&
				   y + yspeed - size <= y2)              
              coll|=2;								                 
         }
    return coll;
}

blocks::blocks()
{
    x=4;
    y=10;
    matrix=new int*[x];
    for(int i=0;i<x;i++)                   
    matrix[i]=new int[y];
    
    for(int i=0;i<x;i++)               
    for(int j=0;j<y;j++)
    matrix[i][j]=0;    
}

blocks::~blocks()
{
for (int i=0; i<x; i++) delete matrix[i];
delete[] matrix;
}

void blocks::blockhit(int i,int j)
{ 
   matrix[i][j]=0;                  
}

bool blocks::blockexistst(int i,int j)
{
  if (matrix[i][j]>0)
  return true;
  else 
  return false;
}

bool blocks::won()
{
int count=0;
for(int i=0;i<x;i++)
for(int j=0;j<y;j++)
if (blockexistst(i,j))
count++;
if (count>0)
return false;
else
return true;
}

rect blocks::getblockrect(int i,int j)
{
 rect blok;
 blok.left = j*width;
 blok.top = i*20;
 blok.right = (j*width)+width;
 blok.bottom = (i*20)+20;                
 return blok;
}

void blocks::draw()
{       
    GLfloat x1,x2,y1,y2;
    glLoadIdentity();
    for(int i=0;i<x;i++)                   
    for(int j=0;j<y;j++)
    {
       if (matrix[i][j]!=0)
       {                      
          x1=j*width+1; 
          x2=j*width+width;
          y1=(GLfloat)i*20.0f+1;
          y2=(GLfloat)i*20.0f+20.0f;  

          switch(matrix[i][j]){
          case 1:glColor3f(1.0f,0.0f,0.0f);break;                               
          case 2:glColor3f(0.0f,1.0f,0.0f);break;                               
          case 3:glColor3f(0.0f,0.0f,1.0f);break;                                                   
          }      
          glBegin(GL_QUADS);                                       
           glVertex3f(x1, y1, 0.0f);           // Top Left
           glVertex3f(x2, y1, 0.0f);       // Top Right
           glVertex3f(x2, y2, 0.0f);// Bottom Right
           glVertex3f(x1, y2, 0.0f);    // Bottom Left
          glEnd();           
       }          
    }
}

void blocks::read(int level,GLfloat boxwidth)
{
 int tmp;  
 ifstream infile;
 if (level<1)
 level=1;
 infile.open("levels.dat",ios::binary);
 if(infile.is_open())
 {
    for (int i=0; i<x; i++) delete matrix[i];
    delete[] matrix;                     
    for(int z=0;z<level;z++){    
     infile.read((char*)&tmp,sizeof(int));
     x=tmp;
     infile.read((char*)&tmp,sizeof(int));    
     y=tmp;
     if (z!=level-1)
     infile.seekg(x*y*sizeof(int),ios::cur);
    }
    matrix=new int*[x];
    for(int i=0;i<x;i++)                   
    matrix[i]=new int[y];        
    for(int i=0;i<x;i++)
    for(int j=0;j<y;j++)
    infile.read((char*)&(matrix[i][j]),sizeof(int));;    
    width=(boxwidth/y)-0.1f;	                         
 }     
}

void blocks::save()
{
  ofstream outfile;     
  outfile.open("levels.dat",ios::binary|ios::app);
  if(outfile.is_open()){
    outfile.write((char*)&x,sizeof(int));;
    outfile.write((char*)&y,sizeof(int));;    
    for(int i=0;i<x;i++)
    for(int j=0;j<y;j++)
    outfile.write((char*)&(matrix[i][j]),sizeof(int));;    
    outfile.close();
  }
}

/*
int blocks::generate(int mx, int my,GLfloat boxwidt)
{
    for (int i=0; i<x; i++) delete matrix[i];
    delete[] matrix;             
    matrix=new int*[mx];
    for(int i=0;i<mx;i++)                   
    matrix[i]=new int[my];          
    x=mx;
    y=my;
    for(int i=0;i<mx;i++)
    for(int j=0;j<my;j++)                 
    matrix[i][j]=3;
    //A  
    matrix[0][2]=2;
    matrix[1][2]=2;
    matrix[2][2]=2;    
    matrix[4][2]=2;        
    matrix[2][3]=2;
    matrix[0][3]=2;    
    matrix[0][4]=2;    
    matrix[1][4]=2;        
    matrix[2][4]=2;            
    matrix[3][4]=2;    
    matrix[4][4]=2;        
    matrix[3][2]=2;        
    //L
    matrix[0][5]=3;            
    matrix[1][5]=3;                
    matrix[2][5]=3;                
    matrix[3][5]=3;                    
    matrix[4][5]=3;                
    matrix[4][6]=3;            
    matrix[4][7]=3;                
    //G
    matrix[0][8]=2;            
    matrix[1][8]=2;            
    matrix[2][8]=2;                    
    matrix[3][8]=2;                
    matrix[4][8]=2;                    
    matrix[0][9]=2;                        
    matrix[0][10]=2;
    matrix[4][9]=2;                            
    matrix[4][10]=2;                                
    matrix[3][10]=2;    
    //O
    matrix[0][11]=3;            
    matrix[1][11]=3;            
    matrix[2][11]=3;            
    matrix[3][11]=3;        
    matrix[4][11]=3;            
    matrix[4][12]=3;            
    matrix[4][13]=3;                
    matrix[0][13]=3;                
    matrix[0][12]=3;                    
    matrix[1][13]=3;                    
    matrix[2][13]=3;                    
    matrix[3][13]=3;                    
    //R
    matrix[0][14]=2;              
    matrix[1][14]=2;              
    matrix[2][14]=2;              
    matrix[3][14]=2;                            
    matrix[4][14]=2;                  
    matrix[0][15]=2;                  
    matrix[0][16]=2;                      
    matrix[1][16]=2;                          
    matrix[3][16]=2;                          
    matrix[2][15]=2;                      
    matrix[4][16]=2;                          
    //Y
    matrix[0][17]=3;                          
    matrix[1][17]=3;    
    matrix[0][19]=3;    
    matrix[1][19]=3;
    matrix[2][18]=3;
    matrix[3][18]=3;    
    matrix[4][18]=3;    
    //T
    matrix[0][20]=2;
    matrix[0][21]=2;
    matrix[0][22]=2;        
    matrix[1][21]=2;    
    matrix[2][21]=2;    
    matrix[3][21]=2;    
    matrix[4][21]=2;                
    //M
    matrix[0][23]=3;    
    matrix[1][24]=3;
    matrix[0][25]=3;
    matrix[1][23]=3;    
    matrix[2][23]=3;    
    matrix[3][23]=3;        
    matrix[4][23]=3;            
    matrix[1][25]=3;        
    matrix[2][25]=3;        
    matrix[3][25]=3;                
    matrix[4][25]=3;            
    width=(boxwidt/my)-0.1f;    
}    */


void bat::draw()
{         
  glLoadIdentity();          
  glColor3f(1.0f,0.2f,0.3f);                                              
  glBegin(GL_QUADS);                                       
      glVertex3f(x, y, 0.0f);           // Top Left
      glVertex3f(x+width, y, 0.0f);       // Top Right
      glVertex3f(x+width, y+height, 0.0f);// Bottom Right
      glVertex3f(x, y+height, 0.0f);    // Bottom Left
  glEnd();        
}

bat::bat()
{
 x=0;
 y=0; 
 width=40;          
 height=15;
 maxx=0;
}

void bat::move(int i)
{ 
 x+=i;
 if (x<0)
 x=0;
 if (x+width>maxx)
 x=maxx-width;
}

void bat::movemouse(int i)
{     
 x=i-width/2;
 if (x<0)
 x=0;
 if (x+width>maxx)
 x=maxx-width;
}

